/* Tabela TABLAYOUTIMP: TABELA DO LAYOUT DE IMPORTAO GENERICA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TABLAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABLAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_TABLAYOUTIMP
AFTER DELETE OR INSERT OR UPDATE
ON TABLAYOUTIMP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
	        IF NVL(:NEW.CDLAYOUTIMP,'NULL') <> NVL(:OLD.CDLAYOUTIMP,'NULL') THEN    
			V_DESC := 'Cd Layout Imp ' || '' || NVL(:NEW.CDLAYOUTIMP,'' );
		END IF;
		IF NVL(:NEW.NRSEQTABELAY,'NULL') <> NVL(:OLD.NRSEQTABELAY,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Nr Seq da Tabela ' || '' || NVL(:NEW.NRSEQTABELAY,'');
		END IF;
		IF NVL(:NEW.NMTABELABD,'NULL') <> NVL(:OLD.NMTABELABD,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NMTABELABD ' || '' || NVL(:NEW.NMTABELABD,'');
		END IF;
		IF NVL(:NEW.NRORDIMPLAY,'NULL') <> NVL(:OLD.NRORDIMPLAY,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Nr Ordem da imp ' || '' || NVL(:NEW.NRORDIMPLAY,'');
		END IF;
		IF NVL(:NEW.NMARQLAYIMP,'NULL') <> NVL(:OLD.NMARQLAYIMP,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Nm do Arquivo ' || '' || NVL(:NEW.NMARQLAYIMP,'');
		END IF;
      V_ITPESQ := :NEW.CDLAYOUTIMP||:NEW.NRSEQTABELAY;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Cd Layout Imp '           || '' || NVL(:NEW.CDLAYOUTIMP,'' )   || ' ' ||
                  'Nr Seq da Tabela '        || '' || NVL(:NEW.NRSEQTABELAY,'')   || ' ' ||
                  'NMTABELABD'               || '' || NVL(:NEW.NMTABELABD,''  )   || ' ' ||
                  'Nr Ordem da imp '         || '' || NVL(:NEW.NRORDIMPLAY,'' )   || ' ' ||
                  'Nm do Arquivo '           || '' || NVL(:NEW.NMARQLAYIMP,'' );
      V_ITPESQ := :NEW.CDLAYOUTIMP||:NEW.NRSEQTABELAY;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cd Layout Imp '           || '' || NVL(:OLD.CDLAYOUTIMP,'' )   || ' ' ||
                  'Nr Seq da Tabela '        || '' || NVL(:OLD.NRSEQTABELAY,'')   || ' ' ||
                  'NMTABELABD'               || '' || NVL(:OLD.NMTABELABD,''  )   || ' ' ||
                  'Nr Ordem da imp '         || '' || NVL(:OLD.NRORDIMPLAY,'' )   || ' ' ||
                  'Nm do Arquivo '           || '' || NVL(:OLD.NMARQLAYIMP,'' ); 
      V_ITPESQ := :OLD.CDLAYOUTIMP||:OLD.NRSEQTABELAY;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND)
   VALUES
      ('TABLAYOUTIMP',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_TABLAYOUTIMP','5.20.001'); END;
/

